//
// TinyPTC by Gaffer
// www.gaffer.org/tinyptc
//

#include "../stdafx.h"
#include <timeapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "../tinyptc.h"

//------------------------------------------------------------
// Setup screen
int ZOOM = 2;
int WIDTH = 320;
int HEIGHT = 240;
#define SIZE 640*480

// Setup a buffer for our reading and writing (FrameBuffer)
static int buffer[SIZE];

#define PI 3.141593

typedef struct
{
	int r, g, b;
} col;

//extern "C" int ptc_open(char *title, int width, int height);
//extern "C" int ptc_update(void *buffer);

//--- effects
#define SCROLLTXT
#define PARALLAX
// Function declares
void Cls(int rgb);
void WritePixel(int x, int y, int rgb);
//
void stopzic();
void initSize();
void initfx();
void render_effect();
void DrawImage(unsigned char* img, int xpos, int ypos, int sx, int sy);

//----------- draw bitmap 
void DrawImage(int* img, int xpos, int ypos, int sx, int sy, int mask);
// var bitmap
#define imgx 320
#define imgy 74
int* ptimg;
#include "scoopexlogo.h"
//-----------------------------------------------------------------
// Our Functions
//-----------------------------------------------------------------
#ifdef SCROLLTXT
#include "FX/Scrolls.h"
#endif


void initSize(void)
{
	WIDTH *= ZOOM;
	HEIGHT *= ZOOM;
	GRDSTARTX = 0;
	GRDSTARTY *= ZOOM;
#ifdef SCROLLTXT
	SPEEDSCROLL *= ZOOM;
	SCROLLW *= ZOOM;
	SCROLLY *= ZOOM;
#endif
#ifdef PARALLAX
	PARSTARTY *= ZOOM;
	MPARSTARTY *= ZOOM;
#endif
}

int main()
{
	DWORD Temps_Ecoule = 0;	//permet de synchroniser les FPS (images par seconde)
													// Open our window/screen
	int quit = 0;
	timeBeginPeriod(1);

	ZOOM = 2;

	initSize();
	// Open our window/screen
	if (!ptc_open("VrS! Scoopex Fred remake", WIDTH, HEIGHT)) return 1;

	initfx();

	do
	{
		//on lance l'affichage en synchronisant les FPS
		if (timeGetTime() - Temps_Ecoule >= (1000 / 60))	//60 fps (1000 ms /16.6 ms)
		{
			Temps_Ecoule = timeGetTime();
			render_effect();
		}

	} while (!quit);

	timeEndPeriod(1);
	return 0;
}

//-----------------------------------------
void initfx()
{
	// init
	ptimg = logo_raw;
	initParallax();
	initFont();
}

void render_effect()
{
	Cls(0); // clear screen
					// draw
	DrawImage(ptimg, 0, 0, imgx, imgy, RGB(0, 0, 0));
#ifdef PARALLAX
	DoParallax();
#endif
#ifdef SCROLLTXT
	DoScrollText();
#endif
	DoGradient();
	ptc_update(buffer); // update screen with DDraw
}
//--------------------------------------------
// Common Functions
//--------------------------------------------

// clear screen
void Cls(int rgb)
{
	int x;
	int y;
	//Do cls stuff
	for (y = 0; y<HEIGHT; y++)
	{
		for (x = 0; x<WIDTH; x++)
		{
			buffer[(y*WIDTH + x)] = rgb;
		}
	}
}

// plot a pixel
void WritePixel(int x, int y, int rgb)
{
	//Do write pixel
	if (x>-1)
	{
		if (x<WIDTH)
		{
			if (y>-1)
			{
				if (y<HEIGHT)
				{
					buffer[(y*WIDTH + x)] = rgb;
				}
			}
		}
	}
}

// function
void DrawImage(int* img, int xpos, int ypos, int sx, int sy, int mask)
{
	int x, y, pixel, txp = 0, typ = 0;

	for (y = 0; y <= sy - 1; y++)
	{
		txp = 0;
		for (x = 0; x <= sx - 1; x++)
		{
			pixel = *(img + x + y*sx);
			if (pixel != mask)
			{
				WritePixel(txp + xpos, typ + ypos, RGB((pixel >> 16) & 255, (pixel >> 8) & 255, (pixel)& 255));
				if (ZOOM == 2)
				{
					WritePixel(txp + xpos, typ + ypos + 1, RGB((pixel >> 16) & 255, (pixel >> 8) & 255, (pixel)& 255));
					WritePixel(txp + xpos + 1, typ + ypos + 1, RGB((pixel >> 16) & 255, (pixel >> 8) & 255, (pixel)& 255));
					WritePixel(txp + xpos + 1, typ + ypos, RGB((pixel >> 16) & 255, (pixel >> 8) & 255, (pixel)& 255));
				}
			}
			txp += ZOOM;
		}
		typ += ZOOM;
	}
}
