//
// TinyPTC by Gaffer
// www.gaffer.org/tinyptc
//

#include "../stdafx.h"
#include <timeapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "../tinyptc.h"

#define PI 3.141593

typedef struct
{
	int r, g, b;
} col;

//extern "C" int ptc_open(char *title, int width, int height);
//extern "C" int ptc_update(void *buffer);

//--- effects
#define WRITER
#define RASTERL
#define ROLL
#define PLASMA
// Function declares
void Cls(int rgb);
void WritePixel(int x, int y, int rgb);
//
void stopzic();
void initSize();
void initfx();
void render_effect();
void DrawImage(unsigned char* img, int xpos, int ypos, int sx, int sy);

//-----------------------------------------------------------------
// Our Functions
//-----------------------------------------------------------------
#include "logo_raw.h"

#define SIZE 640*480 // max size (no dynamic alloc...lame!)
int ZOOM = 1;
int WIDTH = 320;
int HEIGHT = 240;
// Setup a buffer for our reading and writing (FrameBuffer)
static int buffer[SIZE];
//----------- draw bitmap 
#ifdef RASTERL
#include "FX/Rasters.h"
#endif
#ifdef WRITER
#include "FX/Writers2.h"
#endif

// var bitmap
int logox = 320;
int logoy = 44;
unsigned char* ptlogo;


int main()
{
	DWORD Temps_Ecoule = 0;	//permet de synchroniser les FPS (images par seconde)
													// Open our window/screen
	int quit = 0;
	timeBeginPeriod(1);

	ZOOM = 2;

	initSize();
	// Open our window/screen
	if (!ptc_open("VrS! TRSI REMAKE", WIDTH, HEIGHT)) return 1;

	initfx();

	do
	{
		//on lance l'affichage en synchronisant les FPS
		if (timeGetTime() - Temps_Ecoule >= (1000 / 60))	//60 fps (1000 ms /16.6 ms)
		{
			Temps_Ecoule = timeGetTime();
			render_effect();
		}

	} while (!quit);

	timeEndPeriod(1);
	return 0;
}

//-----------------------------------------
void initSize(void)
{
	WIDTH *= ZOOM;
	HEIGHT *= ZOOM;
	RASTERY1 *= ZOOM;
	RASTERY2 *= ZOOM;
	ptlogo = logo_raw;
#ifdef WRITER
	WRITERSTARTX *= ZOOM;
	WRITERSTARTY *= ZOOM;
	posscrollv *= ZOOM;
	ptfont = font_raw;
#endif
}

void initfx()
{
#ifdef RASTERL
	initRasterL();
#endif
#ifdef PLASMA
	initPlasma();
#endif
#ifdef WRITER
	initWriter();
#endif
}

void render_effect()
{
	Cls(0); // clear screen
#ifdef RASTERL
	DoRasterL();
#endif
	DrawImage(ptlogo, 0, (HEIGHT - logoy*ZOOM) / 2, logox, logoy);
#ifdef PLASMA
	DoPlasma();
#endif
#ifdef WRITER
	DoWriter();
#endif

	ptc_update(buffer); // update screen with DDraw
}
//--------------------------------------------
// Common Functions
//--------------------------------------------

// clear screen
void Cls(int rgb)
{
	int x;
	int y;
	//Do cls stuff
	for (y = RASTERY1 + 4; y<RASTERY2; y++)
	{
		for (x = 0; x<WIDTH; x++)
		{
			buffer[(y*WIDTH + x)] = rgb;
		}
	}
}

// plot a pixel
void WritePixel(int x, int y, int rgb)
{
	//Do write pixel
	if (x>-1)
	{
		if (x<WIDTH)
		{
			if (y>-1)
			{
				if (y<HEIGHT)
				{
					buffer[(y*WIDTH + x)] = rgb;
				}
			}
		}
	}
}

int GetPixelPTC(int x, int y, int rgb)
{
	int col = 0;
	//Do write pixel
	if (x>-1)
	{
		if (x<WIDTH)
		{
			if (y>-1)
			{
				if (y<HEIGHT)
				{
					col = buffer[(y*WIDTH + x)] = rgb;
				}
			}
		}
	}
	return col;
}

// to do: mix the 2 routines in one

void DrawImage(unsigned char* img, int xpos, int ypos, int sx, int sy)
{
	int x, y, pixel, col, txp = 0, typ = 0;

	for (y = 0; y<sy; y++)
	{
		txp = 0;
		for (x = 0; x<sx; x++)
		{
			pixel = *(img + x + y*sx);
			col = 0xFFFFFF; // white logo
			if (pixel != 0)
			{
				WritePixel(txp + xpos, typ + ypos, col);
				if (ZOOM == 2)
				{
					WritePixel(txp + xpos + 1, typ + ypos, col);
					WritePixel(txp + xpos + 1, typ + ypos + 1, col);
					WritePixel(txp + xpos, typ + ypos + 1, col);
				}
			}
			txp += ZOOM;
		}
		typ += ZOOM;
	}
}
