//
// TinyPTC by Gaffer
// www.gaffer.org/tinyptc
//

#include "../stdafx.h"
#include <timeapi.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "../tinyptc.h"


#define SIZE 640*480 // size max
int ZOOM = 1;
float RATIO = 1.2f;
int WIDTH = 320;
int HEIGHT = 240;
#define PI 3.141593

typedef struct
{
	int r, g, b;
} col;


static int buffer[SIZE];

// Function declares
void Cls(int rgb);
void WritePixel(int x, int y, int rgb);
//
void initfx();
void initSize(void);
void render_effect();

//--- effects
#define STARS
#define RASTERL
#define WRITER
#define SCROLLTXT

#ifdef STARS
#include "FX/Starfields.h"
#endif
#ifdef RASTERL
#include "FX/Rasters.h"
#endif
#ifdef SCROLLTXT
#include "FX/Scrolls.h"
#endif
#ifdef WRITER
#include "FX/Writers2.h"
#endif



int main()
{
	DWORD Temps_Ecoule = 0;	//permet de synchroniser les FPS (images par seconde)
													// Open our window/screen
	timeBeginPeriod(1);

	ZOOM = 2;
	initSize();

	if (!ptc_open("VrS! Stars", WIDTH, HEIGHT)) return 1;

	initfx();

	// main loop exit
	while (1)
	{
		//on lance l'affichage en synchronisant les FPS
		if (timeGetTime() - Temps_Ecoule >= (1000 / 60))	//60 fps (1000 ms /16.6 ms)
		{
			Temps_Ecoule = timeGetTime();
			render_effect();
		}
	}

	// TODO : mettre a  la destruction
	timeEndPeriod(1);
	return 0;
}

void initSize(void)
{
	CHAR_W2 *= ZOOM;
	CHAR_H2 *= ZOOM;
	WIDTH *= ZOOM;
	HEIGHT *= ZOOM;
	RASTERY1 *= ZOOM;
	RASTERY2 = RASTERY1 + 175 * ZOOM;
	RATIO /= ZOOM;
	WRITERSTARTX = 2 * CHAR_W2 + CHAR_W2 / 2;
	WRITERSTARTY = RASTERY1 + 5;
	SIZEGRADX = maxchar*CHAR_W2;
	SIZEGRADY = maxline*(CHAR_H2 + 2);
	SPEEDSCROLL *= ZOOM;
	if (ZOOM == 2) ptfont = font, ptmask = mask; else ptfont = font1, ptmask = mask1;
}

//-----------------------------------------
void initfx()
{
#ifdef STARS
	InitHStars();
#endif

#ifdef RASTERL
	initRasterL();
#endif
}

void render_effect()
{
	Cls(0); // clear screen

#ifdef STARS
	HStars();
#endif

#ifdef RASTERL
	DoRasterL();
#endif

#ifdef WRITER
	DoWriter();
#endif
	
#ifdef SCROLLTXT
	DoScrollText();
#endif


	ptc_update(buffer); // update screen with DDraw
}

// clear screen
void Cls(int rgb)
{
	int x;
	int y;
	//Do cls stuff
	for (y = 0; y<HEIGHT; y++)
	{
		for (x = 0; x<WIDTH; x++)
		{
			buffer[(y*WIDTH + x)] = rgb;
		}
	}
}

// plot a pixel
void WritePixel(int x, int y, int rgb)
{
	//Do write pixel
	if (x>-1)
	{
		if (x<WIDTH)
		{
			if (y>-1)
			{
				if (y<HEIGHT)
				{
					buffer[(y*WIDTH + x)] = rgb;
				}
			}
		}
	}
}
